<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Static SystemConfig &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="SystemConfigBlueprint" href="systemconfigblueprint.html" />
    <link rel="prev" title="Observation_EntityRepository" href="../outputs/observation_repository.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../30_configs_in_depth.html">Configs in Depth</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="profilescatalog.html">ProfilesCatalog</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario.html">Scenario</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenario_api_support.html">Scenario API Support</a></li>
<li class="toctree-l2"><a class="reference internal" href="scenery.html">Scenery</a></li>
<li class="toctree-l2"><a class="reference internal" href="simulationconfig.html">SimulationConfig</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Static SystemConfig</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#ssp">SSP</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#example">Example</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#connecting-ssp-with-openpass">Connecting SSP with OpenPass</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#id1">Example</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="systemconfigblueprint.html">SystemConfigBlueprint</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../30_configs_in_depth.html">Configs in Depth</a></li>
      <li class="breadcrumb-item active">Static SystemConfig</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/user_guide/configs/staticsystemconfig.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="static-systemconfig">
<span id="staticsystemconfig"></span><h1>Static SystemConfig<a class="headerlink" href="#static-systemconfig" title="Link to this heading"></a></h1>
<p>SystemConfig files are optional.
They describe static configurations of agents and are therefore an alternative to the dynamic sampling of an agent during runtime.
The schema is the same as for the <a class="reference internal" href="systemconfigblueprint.html#systemconfigblueprint"><span class="std std-ref">SystemConfigBlueprint</span></a>.</p>
<section id="ssp">
<h2>SSP<a class="headerlink" href="#ssp" title="Link to this heading"></a></h2>
<p>One usecase for the static SystemConfig is <a class="reference internal" href="../../advanced_topics/simulator/system_structure_and_parameterization_%28SSP%29.html#ssp"><span class="std std-ref">System Structure and Parameterization (SSP)</span></a>.
We use SSP to chain multiple FMUs together, which transfer data between them during one time step.
SSP is added to the SystemConfig like any other Component. It requires the following parameters:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Tag</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Mandatory</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>id</p></td>
<td><p>Id should be set to “SspPath”</p></td>
<td><p>yes</p></td>
</tr>
<tr class="row-odd"><td><p>type</p></td>
<td><p>type should be string</p></td>
<td><p>yes</p></td>
</tr>
<tr class="row-even"><td><p>unit</p></td>
<td><p>not used</p></td>
<td><p>no</p></td>
</tr>
<tr class="row-odd"><td><p>value</p></td>
<td><p>relative path to the ssp file
relative to the configuration path</p></td>
<td><p>yes</p></td>
</tr>
</tbody>
</table>
<section id="example">
<h3>Example<a class="headerlink" href="#example" title="Link to this heading"></a></h3>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">            </span><span class="nt">&lt;component</span><span class="w"> </span><span class="na">doc=</span><span class="s">&quot;SSP&quot;</span><span class="nt">&gt;</span>
<span class="w">                </span><span class="nt">&lt;id&gt;</span>SSP1<span class="nt">&lt;/id&gt;</span>
<span class="w">                </span><span class="nt">&lt;schedule&gt;</span>
<span class="w">                    </span><span class="nt">&lt;priority&gt;</span>50<span class="nt">&lt;/priority&gt;</span>
<span class="w">                    </span><span class="nt">&lt;offset&gt;</span>0<span class="nt">&lt;/offset&gt;</span>
<span class="w">                    </span><span class="nt">&lt;cycle&gt;</span>100<span class="nt">&lt;/cycle&gt;</span>
<span class="w">                    </span><span class="nt">&lt;response&gt;</span>0<span class="nt">&lt;/response&gt;</span>
<span class="w">                </span><span class="nt">&lt;/schedule&gt;</span>
<span class="w">                </span><span class="nt">&lt;library&gt;</span>Algorithm_SspWrapper<span class="nt">&lt;/library&gt;</span>
<span class="w">				</span><span class="nt">&lt;parameters&gt;</span>
<span class="w">                    </span><span class="nt">&lt;parameter&gt;</span>
<span class="w">                        </span><span class="nt">&lt;id&gt;</span>SspPath<span class="nt">&lt;/id&gt;</span>
<span class="w">                        </span><span class="nt">&lt;type&gt;</span>string<span class="nt">&lt;/type&gt;</span>
<span class="w">                        </span><span class="nt">&lt;unit/&gt;</span>
<span class="w">                        </span><span class="nt">&lt;value&gt;</span>ConnectionTest.ssp<span class="nt">&lt;/value&gt;</span>
<span class="w">                    </span><span class="nt">&lt;/parameter&gt;</span>
<span class="w">                </span><span class="nt">&lt;/parameters&gt;</span>
<span class="w">            </span><span class="nt">&lt;/component&gt;</span>
</pre></div>
</div>
</section>
</section>
<section id="connecting-ssp-with-openpass">
<h2>Connecting SSP with OpenPass<a class="headerlink" href="#connecting-ssp-with-openpass" title="Link to this heading"></a></h2>
<p>During OpenPass Simulation, information is communicated via osi messages between the Simulation Core and SSP.
Like any other component communication, these connections need to be explicitly declared as connections in the SystemConfig.
One connection is defined with the following attributes:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Tag</p></th>
<th class="head"><p>Description</p></th>
<th class="head"><p>Mandatory</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>id</p></td>
<td><p>unique identifier for connection</p></td>
<td><p>yes</p></td>
</tr>
<tr class="row-odd"><td><p>source</p></td>
<td><p>pair of sending agent component and local link id</p></td>
<td><p>yes</p></td>
</tr>
<tr class="row-even"><td><p>target</p></td>
<td><p>pair of receiving agent component
and local link id</p></td>
<td><p>yes</p></td>
</tr>
</tbody>
</table>
<section id="id1">
<h3>Example<a class="headerlink" href="#id1" title="Link to this heading"></a></h3>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">           </span><span class="nt">&lt;connection</span><span class="w"> </span><span class="na">doc=</span><span class="s">&quot;SSP&quot;</span><span class="nt">&gt;</span>
<span class="w">                </span><span class="nt">&lt;id&gt;</span>502<span class="nt">&lt;/id&gt;</span>
<span class="w">                </span><span class="nt">&lt;source&gt;</span>
<span class="w">                    </span><span class="nt">&lt;component&gt;</span>SSP1<span class="nt">&lt;/component&gt;</span>
<span class="w">                    </span><span class="nt">&lt;output&gt;</span>0<span class="nt">&lt;/output&gt;</span>
<span class="w">                </span><span class="nt">&lt;/source&gt;</span>
<span class="w">                </span><span class="nt">&lt;target&gt;</span>
<span class="w">                    </span><span class="nt">&lt;component&gt;</span>PrioritizerDynamics<span class="nt">&lt;/component&gt;</span>
<span class="w">                    </span><span class="nt">&lt;input&gt;</span>1<span class="nt">&lt;/input&gt;</span>
<span class="w">                </span><span class="nt">&lt;/target&gt;</span>
<span class="w">            </span><span class="nt">&lt;/connection&gt;</span>
</pre></div>
</div>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="../outputs/observation_repository.html" class="btn btn-neutral float-left" title="Observation_EntityRepository" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="systemconfigblueprint.html" class="btn btn-neutral float-right" title="SystemConfigBlueprint" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>